# -------------------------------------------------------------------------
# display.pm, authored by paal@ekran.no, Mon Aug 28 11:44:40 CEST 2000

#
# handle everythings that relates to displaying messages on the screen, this
# is considered to be the main view, a split screen with messages info at
# the top and message printout at the bottom.
#

# -------------------------------------------------------------------
# display messages in current box

sub display_headers()
{
    my $cnt;
    my $col;
	my $code;

	my $eline,$mf,$cf;

	# first we generate $eline which contains the lines with info on each
	# email in this folder.
    $cnt=0;
	$eline="";
    $ci=$i_nmh."/scan -width 200 -reverse all -form ".$i_wmhome."/scan.main |";
    open TXT,$ci; # perform mail scan.
    while ($line=<TXT>)
    {
        chomp $line;
        ($id,$stat,$dt,$from,$subj)=split /WMHsplit42/,$line;
        if ($stat eq "()") {$stat=""}

        if (++$cnt/2==(int($cnt/2))) # change colours every second line
        {
            $col=$c_backdrop_r;
        } else {
            $col=$c_backdrop_l;
        }

        $id=int($id); # convert to int and write mail info for each message
        $eline=$eline.'<tr>
               <td bgcolor="'.$col.'" align="center">'.$c_fontL.$id.'</td>
               <td bgcolor="'.$col.'" align="center">
                    <input type="checkbox" name="d'.$id.'"></td>
               <td bgcolor="'.$col.'" align="center">'.
                    $c_fontL.$dt.$c_fontL.$stat.'</td>
               <td bgcolor="'.$col.'" align="left" width="75%"><font size="-1">
                <b>'.$c_fontL.$from.'</b><br>
                <a href="webmh.cgi?USHOW='.int($id).'&UACT=mtail" target="F2">'.
                $c_fontL.html_encode($subj).'</td>
                </tr>';
    }
    close TXT;

	$cf=&display_handle_change_folders(); # html for top cfolder sel.
	$ms=&display_single_folder_move_selector(
			"Move marked messages to:","movMarked"); # bottom move marked sel.
	$code=&html_display_headers($cf,$eline,$ms); # generate the whole page.

	return ($code);
}


# -------------------------------------------------------------------
# display a message (input parameter is message number)
sub display_message()
{
    my ($mno,$ups)=@_;
    my $chk,$cnt;
    my $nempty;

	my $code;
	my $amsg;

    if (!$ushow) { ($ushow)=get_current_message(); }

    $state=tools_expanded($unam);
	$amsg="";

	# ---- read the current message into $amsg;
    $chk=0; $cnt=0;
    open TXT,$i_nmh."/show -noheader -noshowproc ".$mno." |";
    while ($line=<TXT>)
    {
        chomp $line;
        if ($chk==0) # $chk==0 => we're in the header
        {
            if ($line eq "") # empty line? => end of header
            {
				$amsg=$amsg.'[ <a href="'.$cgi_url.'webmh.cgi?UACT=';
                if (!($state))
                {
                    $amsg=$amsg.'expand" target="_top">expand</a> ]</b>';
                } else {
                    $amsg=$amsg.'shrink" target="_top">shrink</a> ]</b>';
                }
                $amsg=$amsg."\n\n";
                $chk=1;
            }

            $_=$line; # for the /^ search line
            if ($state) # write header information
            {
                $amsg=$amsg.&html_encode($line)."\n";
            } elsif (/^From:/ || /^Subject:/ || /^Date:/ || /^To:/) {
                $amsg=$amsg.&html_encode($line)."\n";
            }

        } else {
            $amsg=$amsg.&html_encode($line)."\n";
        }

    }
    close TXT;

	# ----------------------
	# now generate some html

	$code='<br><table width="100%" border="0"
                cellspacing="0" cellpadding="0" bgcolor="'.$c_backdrop.'">
            <tr><td>'.$c_fontBar.'Message No. ';

    $nempty=1; # assume there is a current message
    if (!($ushow)) {
        $code=$code."[ none selected ]"; $nempty=0; # no current message
    } else { $code=$code.$ushow; }

    $code=$code.'</font></td><td align=right>'.$c_fontBar;
    if ($nempty) { # only write reply, forward, etc if there is a message
        $code=$code.' [ <a href="webmh.cgi?UACT=compose&USHOW=1&UFLAG=R"
                    target="_top">reply</a> ]
                [ <a href="webmh.cgi?UACT=compose&USHOW=1&UFLAG=F"
                    target="_top">forward</a> ]
                [ <a href="webmh.cgi?UACT=compose&USHOW=2&UFLAG=G"
					target="_top">group-reply</a> ]
                [ <a href="webmh.cgi?UACT=compose&USHOW=1&UFLAG=B"
                    target="_top">bounce</a> ]
                </font>';
    } else { $code=$code.'&nbsp;'; }

    $code=$code.'</td></tr>
			</table>
        <ul><pre><b>'.$amsg;

    if ($ups) { # ups is used to pass data betwenn cgi-bin calls
        $code=$code.$c_fontBar."<p><br><center>".$ups.'</center><br>';
    }

    $code=$code.'</pre></ul>
   		<table width="100%" border="0"
               cellspacing="0" cellpadding="0" bgcolor="'.$c_backdrop.'">
		<tr><td align=left>'.$c_fontL;

    if ($nempty) # only write move/delete if there is a message
    {
        $code=$code.'<b>'.
			&display_single_folder_move_selector("&nbsp;Move to","movs").'</b>
			</td><td align=right>'.$c_fontBar.'
    [ <a href="webmh.cgi?UACT=dels&USHOW='.$ushow.'" target="_top">delete</a> ]
			&nbsp;';
    } else { $code=$code.'&nbsp;<br>'; }

    $code=$code.'</td></tr></table><br>'."\n";

	return ($code);
}

# ----------------------------------------------------------------------
# display the change folder box at the top of the display message screen
sub display_handle_change_folders()
{
    my @folders;
    my $pf,$pfc;

	my $code;

    $code='<form action="webmh.cgi" target="_top">';

    open TXT,$i_nmh.'/folders -noheader -nototal -recurse |';
    while (<TXT>)
    {
        chomp;
        push @folders,$_; # make a list of all the folders
    }
    close TXT;

    $code=$code.'Change to folder: <select name="SFOLDER">';

    ($current)=get_current_folder();
    ($pfc)=get_plain_folder($current,$current);
    $code=$code.'<option value="'.$pfc.'">'.$current.' '."\n";
    foreach $line (@folders)
    {
        ($pf)=get_plain_folder($line,$current);
        if ($pf ne $pfc)
        {
            $code=$code.'<option value="'.$pf.'">'.$line.' '."\n";
        }
    }
    $code=$code.'
		</select><input type="submit" name="CFOLDER" value="ok">
    	</form>
	';

	return ($code);
}

# ----------------------------------------------------------------------
# display_single_folder_move_selector

sub display_single_folder_move_selector()
{
    ($atext,$act)=@_; # atext=output infront of selector, $act=action for $uact

    my @folders;
	my $code;

    open TXT,$i_nmh.'/folders -noheader -nototal -recurse |';
    while (<TXT>)
    {
        chomp;
        push @folders,$_; # make a list of all the folders
    }
    close TXT;

    if (($act ne "movMarked") && ($act ne 'mini'))
	{
		$code='<form action="webmh.cgi" target="_top" method="GET">';
	}

	$code=$code.$atext; # optional text before the selection
    $code=$code.'<select name="SFOLDER">';

    ($current)=get_current_folder();

	# hack to avoid user deletion of inbox.
	if ($act eq 'mini') { $current='inbox+ has n messages (n-n)'; }

    ($pfc)=get_plain_folder($current,$current);
    foreach $line (@folders)
    {
        ($pf)=get_plain_folder($line,$current);
        if ($pf ne $pfc) # don't print the current folder.
        {
            $code=$code.'<option value="'.$pf.'">'.$pf.' '."\n";
        }
    }
    $code=$code.'</select>';

	if ($act ne "mini")
	{
		$code=$code.'<input type="hidden" name="UACT" value="'.$act.'">';
        $code=$code.'<input type="submit" value="ok">';
	}
	$code=$code."\n";

	return ($code);
}

1;
