
# -------------------------------------------------------------------
# send.pm, authoredb by paal@ekran.no, Mon Aug 28 11:01:47 CEST 2000
#
# this module contains everything related to sending messages from
# webmh. 
#

# -------------------------------------------------------------------
# display compose frame -- shows the frame where the user will write
# the message waiting to be sent.

sub send_display_compose_frame()
{
	($uflag)=@_; # G=group reply, R=reply, F=forward, B=bounce

	my $df_to=""; # default to
	my $df_cc=""; # default cc
	my $df_bcc=""; # default bcc
	my $df_subj=""; # default subj
	my $df_mess=""; # default message

	if (($uflag eq "G") || ($uflag eq "R") ||
		($uflag eq "F") || ($uflag eq "B")) # grab info
	{
		($df_to,$df_cc,$df_subj,$df_mess)=send_reply_forward_preconf();
		if ($uflag eq "F") { $df_to=""; } # No To: for forwarding.
	}

	if ($uflag eq "B") { return (&html_send_bounce); } # for bounce
	return (&html_send($df_to,$df_cc,$df_bcc,$df_subj,$df_mess));
}


# ---------------------------------------------------------------------------
# handle, send data and print recipt

sub send_display_compose_send()
{

    print '<br><br><br>';
    open DTA,">".$i_cgif."/draft";
    if ($uflag eq "B")
    {
        $uflag="0";
        ($df_to,$df_cc,$df_subj,$df_mess)=send_reply_forward_preconf();
        $uflag="B";
        print DTA "From: ".$df_to."\n";
        print DTA "To: ".$data{"m_to"}."\n";
        print DTA "Subject: ".$df_subj."\n";
        print DTA "X-Resent-From: ".$u_user."\n";
        print DTA $i_xhead1."\n";
    } else {
        $df_mess=$data{"m_message"};
        print DTA "To: ".$data{"m_to"}."\n";
        print DTA "Cc: ".$data{"m_cc"}."\n";
        print DTA "Bcc: ".$data{"m_bcc"}."\n";
        print DTA "Subject: ".$data{"m_subject"}."\n";
        print DTA $i_xhead1."\n";
    }
    print DTA "--------\n";
    print DTA $df_mess."\n";
    close DTA;

    $i=$i_nmh.'/send -draftmessage ./draft';
    system ($i);
    chmod 0600,"./,draft"; # ensure that nobody else reads the draft

    $dat=`/bin/date`;
    chomp $dat;

	print &html_sent($uflag,$u_user);

}

# ---------------------------------------------------------------------------
# when user select either forward or reply, the following sub grabs
# to, subject and message for the composer.

sub send_reply_forward_preconf()
{
    my $cnt;
    my $df_to;
    my $df_cc,$df_c2;
    my $df_subj;
    my $df_mess;

    $cnt=0;
	$df_cc="";
    open TXT,$i_nmh."/show cur -noheader -noshowproc |";
    while (<TXT>)
    {
        chomp;
        if ($cnt==0)
        {
            if (/^From: .*<(.+?)>/) { $df_to=$1; }
            if (/^From: .*(\".+?\")/) { $df_name=$1; } # get realname
            if (/^Cc: (.*\S)\s*$/) { $df_cc=$1; }
            if (/^To: (.*\S)\s*$/) { $df_c2=$1; }
            if (/^Reply-To: (\S+)/) { $df_to=$1; }
            if (/^Subject: \s*(.*)/) { $df_subj=$1; }
        }
        if ($_ eq "") { $cnt++; }
        if ($uflag ne "R") { $head=$head.$_."\n"; } # assemble header

        if ($cnt>0) { # we don't need no header in the reply form
            if ($df_mess eq "")
            {
                if (($uflag eq "R") || ($uflag eq "G")) { # 1'st line reply to
                    if ($df_name)
					{
						$df_mess=$df_name." <".$df_to."> wrote:\n";
					} else { $df_mess="<".$df_to."> wrote:\n"; }
                }
                if ($uflag eq "F") { # 1'st line forward
                    $df_mess="----- Forwarded message from ".
                        $df_name." <".$df_to."> -----\n\n".$head;
                }
                if ($uflag eq "B") {
                    $df_mess="To: <recipient>\n".
                             "Subject: ".$df_subj."\n".
                             "From: ".$df_to."\n".
                             "X-Bounced-From: ".$u_user."\n";
                }
            }
            if (($uflag eq "G") || ($uflag eq "R"))
			{	
                $df_mess=$df_mess."> ".$_."\n";
            } else {
                $df_mess=$df_mess.$_."\n";
            }
        }
    }
    close TXT;
    if ($uflag eq "F") {
        $df_mess=$df_mess.'----- End forwarded message -----'."\n";
    }
	if ($uflag eq "G")
	{
		# tools_debug($df_cc.":".$df_c2.":".$df_to.":".$df_from.":\n","a");
		if ($df_c2) { $df_cc=$df_cc.",".$df_c2; }
	} else {
		$df_cc="";
	}

	unless ($df_subj=~/^(Re|RE|Sv|SV):/)
	{
		$df_subj="Re: ".$df_subj;
	}

    return ($df_to,$df_cc,$df_subj,$df_mess);
}


1;

